
/* 

	-------------------------------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------------------------------------------------------------------------------------------------------------

						Stefano Mattoccia

						DISI - University of Bologna

						www.vision.deis.unibo.it/smatt

						stefano.mattoccia@unibo.it

						Summer 2010

						If you use this code please cite the following paper:

						S. Mattoccia, S. Giardino, A. Gambini, 
						"Accurate and efficient cost aggregation strategy for stereo correspondence based on approximated joint bilateral filtering"
						Asian Conference on Computer Vision (ACCV2009), September 23- 27, 2009,  Xi'an, China


	-------------------------------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------------------------------------------------------------------------------------------------------------

*/



#include "GlobalDefine.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "cv.h"
#include "highgui.h"
#include "cxcore.h"
#include "cvaux.h"



#ifndef max
#define max(a,b)            (((a) > (b)) ? (a) : (b))
#endif

#ifndef min
#define min(a,b)            (((a) < (b)) ? (a) : (b))
#endif

#ifndef VISUAL_STUDIO_8
#define BYTE unsigned char
#endif  

int init_exponential_lut_ACCV_2009(float gamma_color, int Dim);
void box_filtering_stereo_color_TAD_single_channel_ACCV_2009(int w, int h, int nDisp, int offs_x, IplImage *L, IplImage *R, int** out, int r, int threshold);
void box_filtering_sum_ACCV_2009(int w, int h, int ws, BYTE* raw, int Channel, int* out, int r);
int FastStereoBilateral_ACCV_2009(IplImage *Left, IplImage *Right, IplImage *Result_LR, IplImage *Result_RL, IplImage *Result_LR_SMP, int dmin, int dmax, int radius, int radius_macro, float gamma_space, float gamma_color,int TAD_threshold, int scale);

